; Square root using Newton's method
; using internal definitions to make 
; the helper procedures local.

; Replaced guess and x with ga, gb, 
; gc and xa, xb, xc to highlight the fact
; that they are not all the same object.

(define (sqrtc x)
  
  (define (good-enough? ga xa)
    (< (abs (- (* ga ga) xa)) 0.001))
  
  (define (improve gb xb)
    (/ (+ gb (/ xb gb)) 2.0))
  
  (define (iter gc xc)
    (if (good-enough? gc xc)
        gc
        (iter (improve gc xc) xc )))
  
  (iter 1.0 x))
