; Square root using Newton's method.
; Removed all the x parameters since they
; refer to the globally available x in
; every case.

(define (sqrtd x)
  
  (define (good-enough? ga)
    (< (abs (- (* ga ga) x)) 0.001))
  
  (define (improve gb)
    (/ (+ gb (/ x gb)) 2.0))
  
  (define (iter gc)
    (if (good-enough? gc)
        gc
        (iter (improve gc))))
  
  (iter 1.0))
